#!/usr/bin/env python

from email.mime.multipart import MIMEMultipart
from email.mime.application import MIMEApplication
from email.mime.base import MIMEBase
from email.encoders import encode_noop
from email import message_from_string
import httplib
import sys

if __name__ == "__main__":
    host = sys.argv[1]
    path = sys.argv[2] + "?action=PostMessage"

    try:
        message = sys.argv[3]
        text = open(message).read()
        signature = sys.stdin.read()
        protocol = "application/pgp-signature"
        subtype = "signed"
    except IndexError:
        text = sys.stdin.read()
        signature = None
        protocol = "application/pgp-encrypted"
        subtype = "encrypted"

    # Make the container for the message.

    message = MIMEMultipart(subtype, protocol=protocol)

    # For encrypted content, add the declaration and content.

    if not signature:
        declaration = MIMEBase("application", "pgp-encrypted")
        declaration.set_payload("Version: 1")
        message.attach(declaration)

        content = MIMEApplication(text, "octet-stream", encode_noop)
        message.attach(content)

    # For signed content, 

    else:
        submessage = message_from_string(text)
        message.attach(submessage)

        signature_part = MIMEBase("application", "pgp-signature")
        signature_part.set_payload(signature)
        message.attach(signature_part)

    # Show the resulting message text.

    text = message.as_string()

    print text
    print

    req = httplib.HTTPConnection(host)
    req.request("PUT", path, text) # {"Content-Length" : len(text)}
    resp = req.getresponse()
    print resp.read()

# vim: tabstop=4 expandtab shiftwidth=4
